/*------------------------------------------------*/
/* znakoveSady/utf8io.c                           */
#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <string.h>
#include "utf8fce.h"

#define MIN_STRLEN 5
#define TEXT_LEN (MIN_STRLEN * MAX_BYTES_IN_UTF8 + 1)
typedef char * charUTF8;
#define NULL8 NULL


charUTF8 utf8getc(FILE * stream) {
    static char znak[MAX_BYTES_IN_UTF8 + 1];
    int z, bytes, i;
    
    z = fgetc(stream);
    if(z == EOF) return NULL8;
    znak[0] = z;
    bytes = utf8bytesInChar(znak[0]);
    znak[bytes] = '\0';

    for(i = 1; i < bytes; i++) {
        z = getc(stream);
        if(z == EOF) return NULL8;
        znak[i] = z;
    }

    return znak;
}

char * utf8gets(char *s, size_t size, FILE *stream) {
    charUTF8 znak;
    int count = 0;
    char *end = s;

    do {
        znak = utf8getc(stream);
        if(znak == NULL8) {
            if(!count) return NULL;
            return s;
        }
        strcpy(end, znak);
        end += strlen(znak);
	if(!strcmp("\n",znak)) return s;
    } while(++count < size);
    return s;
}

int main(void) {
    charUTF8 znak;
    char s[TEXT_LEN];

    printf("Zadej řetězec: ");
    utf8gets(s, MIN_STRLEN, stdin);
    printf("Zadal jsi '%s'\n", s);

    printf("Zadej znak: ");
    znak = utf8getc(stdin);
    printf("Zadal jsi '%s'\n", znak);

    return 0;
}
/*------------------------------------------------*/
